<?php

namespace Lavalite\Plan\Providers;

use Illuminate\Contracts\Auth\Access\Gate as GateContract;
use Illuminate\Foundation\Support\Providers\AuthServiceProvider as ServiceProvider;

class AuthServiceProvider extends ServiceProvider
{
    /**
     * The policy mappings for the package.
     *
     * @var array
     */
    protected $policies = [
        // Bind Plan policy
        'Lavalite\Plan\Models\Plan' => \Lavalite\Plan\Policies\PlanPolicy::class,// Bind Feature policy
        'Lavalite\Plan\Models\Feature' => \Lavalite\Plan\Policies\FeaturePolicy::class,// Bind SubscriptionUsage policy
        'Lavalite\Plan\Models\SubscriptionUsage' => \Lavalite\Plan\Policies\SubscriptionUsagePolicy::class,// Bind Subscription policy
        'Lavalite\Plan\Models\Subscription' => \Lavalite\Plan\Policies\SubscriptionPolicy::class,
    ];

    /**
     * Register any package authentication / authorization services.
     *
     * @param \Illuminate\Contracts\Auth\Access\Gate $gate
     *
     * @return void
     */
    public function boot(GateContract $gate)
    {
        parent::registerPolicies($gate);
    }
}
