<?php

namespace Lavalite\Plan\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class PlanTransformer extends TransformerAbstract
{
    public function transform(\Lavalite\Plan\Models\Plan $plan)
    {
        return [
            'id'                => $plan->getRouteKey(),
            'key'               => [
                'public'    => $plan->getPublicKey(),
                'route'     => $plan->getRouteKey(),
            ], 
            'id'                => $plan->id,
            'slug'              => $plan->slug,
            'name'              => $plan->name,
            'sort_order'        => $plan->sort_order,
            'price'             => $plan->price,
            'interval'          => $plan->interval,
            'interval_count'    => $plan->interval_count,
            'trial_period_days' => $plan->trial_period_days,
            'status'            => $plan->status,
            'description'       => $plan->description,
            'created_at'        => $plan->created_at,
            'updated_at'        => $plan->updated_at,
            'deleted_at'        => $plan->deleted_at,
            'url'               => [
                'public'    => trans_url('plan/'.$plan->getPublicKey()),
                'user'      => guard_url('plan/plan/'.$plan->getRouteKey()),
            ], 
            'status'            => trans('app.'.$plan->status),
            'created_at'        => format_date($plan->created_at),
            'updated_at'        => format_date($plan->updated_at),
        ];
    }
}